/*
 * This file is part of the Extra-P software (http://www.scalasca.org/software/extra-p)
 *
 * Copyright (c) 2017,
 * Technische Universitaet Darmstadt, Germany
 *
 * This software may be modified and distributed under the terms of
 * a BSD-style license.  See the COPYING file in the package base
 * directory for details.
 *
 */

#ifndef EXTRAP_MULTI_PARAMETER_MODEL_GENERATOR_HPP
#define EXTRAP_MULTI_PARAMETER_MODEL_GENERATOR_HPP


#include <EXTRAP_ModelGenerator.hpp>
#include <EXTRAP_CompoundTerm.hpp>
#include <EXTRAP_MultiParameterHypothesis.hpp>
#include <EXTRAP_MultiParameterSimpleFunctionModeler.hpp>

namespace EXTRAP
{
// TODO: lift some of these definitions into ModelGenerator superclass?

class MultiParameterFunction;

class MultiParameterModelGenerator : public ModelGenerator
{
public:
    MultiParameterModelGenerator();

    virtual Model*
    createModel( const ExperimentPointList& modeledDataPointList,
                 const Function*            expectationFunction = NULL );


    void
    setModelOptions( GenerateModelOptions options );

    GenerateModelOptions
    getModelOptions( void ) const;

    virtual bool
    serialize( IoHelper* ioHelper ) const;

    void
    deserialize( IoHelper* ioHelper );

protected:
    virtual MultiParameterFunctionModeler&
    getFunctionModeler() const = 0;

    //Start of external state
    GenerateModelOptions m_options;
    //End of external state
};
};

#endif
