## -*- mode: autoconf -*-

##
## This file is part of the Extra-P software (http://www.scalasca.org/software/extra-p)
##
## Copyright (c) 2016-2017,
## Technische Universitaet Darmstadt, Germany
##
## This software may be modified and distributed under the terms of
## a BSD-style license.  See the COPYING file in the package base
## directory for details.
##

## file       extrap_python.m4



dnl Macro that checks for specific modules in python
dnl Need to run AM_PATH_PYRHON before
AC_DEFUN([AC_PYTHON_MODULE],
[AC_MSG_CHECKING(for module $1 in python)
echo "import $1" | $PYTHON -
if test $? -ne 0 ; then
  AC_MSG_RESULT(not found)
  AC_MSG_ERROR(You need the module $1 available to python3 for this package)
fi
AC_MSG_RESULT(found)
])

dnl Macro that checks for PyQt modules in python
dnl Need to run AM_PATH_PYRHON before
AC_DEFUN([AC_PYQT],
[AC_MSG_CHECKING(for module PyQt in python installation)
echo "import PyQt4" | $PYTHON -
if test $? -ne 0 ; then
  echo "import PyQt5" | $PYTHON -
  if test $? -ne 0 ; then
    AC_MSG_RESULT(no PyQt found)
    AC_MSG_ERROR(You need the module PyQt4 or PyQt5 available to python3 for this package)
  fi
  AC_MSG_RESULT(PyQt5 found)
else
  AC_MSG_RESULT(PyQt4 found)
fi
])

dnl Main macro to check for python 3 and required modules and headers
AC_DEFUN([EXTRAP_PYTHON], [
AM_PATH_PYTHON([3])
AC_PYQT
AC_PYTHON_MODULE([matplotlib])

## Check if header is found
AC_CHECK_HEADER(
    [Python.h], 
    [],
    [AC_MSG_ERROR([Python.h not found. Please provide CPPFLAGS with include path for Python.h])]

)]);

    
