# -*- coding: utf-8 -*-
##
## This file is part of the Extra-P software (http://www.scalasca.org/software/extra-p)
##
## Copyright (c) 2016-2017,
## Technische Universitaet Darmstadt, Germany
##
## This software may be modified and distributed under the terms of
## a BSD-style license.  See the COPYING file in the package base
## directory for details.
##

import EXTRAP
try:
   from PyQt4.QtGui import *
except ImportError:
   from PyQt5.QtGui import *
   from PyQt5.QtWidgets import *

class SingleParameterRefiningModeler(QWidget):
   
   def __init__(self, modelerWidget, parent):
      super(SingleParameterRefiningModeler, self).__init__(parent)

      self.modeler_widget = modelerWidget

      self.initUI()

   def initUI(self):
      
      grid = QGridLayout( self )
      self.setLayout( grid )    

      model_button = QPushButton(self)
      model_button.setText( "Generate models")
      model_button.pressed.connect( self.remodel )
      
      grid.addWidget( model_button, 4, 0)

      widget = QWidget( self )
      widget.setMinimumHeight( self.height() - 120 )
      grid.addWidget( widget, 5, 0)

   def getName(self):
      return "Refining Model Generator"

   def remodel(self):
      
      modeler = EXTRAP.SingleParameterRefiningModelGenerator()
      modeler.setEpsilon( 0.01 )
      self.modeler_widget.onGenerate( modeler )

