# -*- coding: utf-8 -*-
##
## This file is part of the Extra-P software (http://www.scalasca.org/software/extra-p)
##
## Copyright (c) 2016-2017,
## Technische Universitaet Darmstadt, Germany
##
## This software may be modified and distributed under the terms of
## a BSD-style license.  See the COPYING file in the package base
## directory for details.
##

import sys,os
import math
import EXTRAP
try:
   from PyQt4.QtGui import *
   from PyQt4.QtCore import *
except ImportError:
   from PyQt5.QtGui import *
   from PyQt5.QtCore import *
   from PyQt5.QtWidgets import *

class TreeView(QTreeView):
   
   def __init__( self, parent ):

      super(TreeView,self).__init__(parent)
      self.setSelectionMode(QAbstractItemView.ExtendedSelection)
   
   def contextMenuEvent( self, event ):
      menu = QMenu()
      if self.model() is not None :
         if self.selectedIndexes():
            selectedCallpath = self.model().getValue(self.selectedIndexes()[0])
            selectedModel = self.model().getSelectedModel(selectedCallpath)
            expandAction = menu.addAction("Expand All")
            expandAction.triggered.connect( self.expandAll )
            showCommentsAction = menu.addAction("Show Comments")
            showCommentsAction.setEnabled(selectedModel is not None and len(selectedModel.getComments()) > 0)
            showCommentsAction.triggered.connect( lambda: self.showComments(selectedModel ))
            menu.exec_(self.mapToGlobal(event.pos()))

   def showComments( self, model ):
      msg = QMessageBox()
      msg.setIcon(QMessageBox.Information)
      msg.setText("Model has the following comments attached (text can be copied to the clipboard using the context menu):")
      allComments = '\n'.join(("– " + c.getMessage()) for c in model.getComments())
      msg.setInformativeText(allComments)
      msg.setWindowTitle("Model Comments")
      #msg.setDetailedText("The details are as follows:")
      msg.setStandardButtons(QMessageBox.Ok)
      msg.exec_()

